﻿'use strict';

var RequestMethod = require('../collector/request-method.js');
var cloudconf = require('../../cloudwise.js');
var sources = require('./source.js');


var remote = new RequestMethod({
    method: 'POST',
    host: '127.0.0.1',
    port: '26789',
    path: '/send',
    ssl: false
});


/**
 * 存储http请求数据
 * @constructor
 */
function sendAllRequest() {

}



sendAllRequest.prototype.getMaps = function (transaction, source, TraceSegment) {

    source.addMaps(TraceSegment.name, TraceSegment.timer.duration*1000, "", "", "", "", TraceSegment.treeNB, "", TraceSegment.pst, 0, "", TraceSegment.ps, "", "", "1", TraceSegment.timer.start, transaction.trace.parameters['request.headers.host'], TraceSegment.service_type)
    if (typeof (TraceSegment.resouce) != "undefined" && TraceSegment.resouce != null) {
        source.addResources(TraceSegment.resouce.tag, TraceSegment.resouce.host, TraceSegment.resouce.dbName, TraceSegment.resouce.port, TraceSegment.resouce.userName);
    }
    if (TraceSegment.children.length > 0) {
        for (var i = 0; i < TraceSegment.children.length; i++) {
            this.getMaps(transaction, source, TraceSegment.children[i]);
        }
    }
}


sendAllRequest.prototype.TN=1;
sendAllRequest.prototype.wowTree={};

/**
 *发送http记录数据
 */
sendAllRequest.prototype.send = function (transaction) {
    var source = new sources()
	this.addTreeNB(transaction.webSegment,this.TN)
    this.getMaps(transaction, source, transaction.webSegment);

    source.setHost_id(cloudconf.cloudwiseConf.HostId);
    source.setAppName(cloudconf.cloudwiseConf.app_name);
    source.setIp(getIPAdress());
    source.setNodeTopic(cloudconf.cloudwiseConf.HostkKey + '_1005_' + (new Date).getTime());
	transaction.webSegment.cid=transaction.webSegment.cid.split(':').length > 1 ? transaction.webSegment.cid.split(':')[3] : "";
    var args = [
    cloudconf.cloudwiseConf.HostkKey + "_" + transaction.id + "@nj:" + cloudconf.cloudwiseConf.HostId + ":" + Date.parse(new Date()),
    transaction.url,
    transaction.trace.parameters["request.headers.host"],
    getIPAdress(),
    transaction.port,
    transaction.webSegment.cid,
    transaction.trace.parameters["request.headers.referer"],
    transaction.timer.start,
    1,
    transaction.timer.duration * 1000,
    '',
    '',
    '',
    transaction.statusCode];
    source.addStart.apply(source, args);
    
	
	this.GenerateTreeStruct(transaction.webSegment,this.wowTree)
	source.setTree(this.wowTree)
	this.wowTree={}
    var s = source.getWowMap()
	
	


	
	



    //source.addResources('2301', segment.host, segment.dbName, segment.port, segment.userName);
    remote.invoke(s, function (res) {
        var body = '';
        if (res.statusCode == 200) {
            res.on('data', function (data) {
               body += data;
            }).on('end', function () {
                console.log(body);
            })
        } else {
            console.log('request is error!')
        }
    });

	
};





sendAllRequest.prototype.GenerateTreeStruct=function(dom, wowTree)
{
    var mapTree = {};
    wowTree[dom.treeNB] = mapTree;
    if (dom.children.length > 0) {
        for (var i = 0; i < dom.children.length; i++) {
            this.GenerateTreeStruct(dom.children[i], wowTree[dom.treeNB]);
        }
    }
}


	sendAllRequest.prototype.addTreeNB = function (TraceSegment) {
    TraceSegment.treeNB = this.TN;
    if (TraceSegment.children.length > 0) {
        for (var i = 0; i < TraceSegment.children.length; i++) {
			this.TN += 1
            this.addTreeNB(TraceSegment.children[i]);
        }
    }
}



function getIPAdress() {
    var interfaces = require('os').networkInterfaces();
    for (var devName in interfaces) {
        var iface = interfaces[devName];
        for (var i = 0; i < iface.length; i++) {
            var alias = iface[i];
            if (alias.family === 'IPv4' && alias.address !== '127.0.0.1' && !alias.internal) {
                return alias.address;
            }
        }
    }
}


module.exports = sendAllRequest;
